# File core/lib/Thelia/Model/om/BaseContentVersionPeer.php | thelia

       1: <?php
       2:
       3: namespace Thelia\Model\om;
       4:
       5: use \BasePeer;
       6: use \Criteria;
       7: use \PDO;
       8: use \PDOStatement;
       9: use \Propel;
      10: use \PropelException;
      11: use \PropelPDO;
      12: use Thelia\Model\ContentPeer;
      13: use Thelia\Model\ContentVersion;
      14: use Thelia\Model\ContentVersionPeer;
      15: use Thelia\Model\map\ContentVersionTableMap;
      16:
      17: /**
      18:  * Base static class for performing query and update operations on the 'content_version' table.
      19:  *
      20:  *
      21:  *
      22:  * @package propel.generator.Thelia.Model.om
      23:  */
      24: abstract class BaseContentVersionPeer
      25: {
      26:
      27:     /** the default database name for this class */
      28:     const DATABASE_NAME = 'thelia';
      29:
      30:     /** the table name for this class */
      31:     const TABLE_NAME = 'content_version';
      32:
      33:     /** the related Propel class for this table */
      34:     const OM_CLASS = 'Thelia\\Model\\ContentVersion';
      35:
      36:     /** the related TableMap class for this table */
      37:     const TM_CLASS = 'ContentVersionTableMap';
      38:
      39:     /** The total number of columns. */
      40:     const NUM_COLUMNS = 8;
      41:
      42:     /** The number of lazy-loaded columns. */
      43:     const NUM_LAZY_LOAD_COLUMNS = 0;
      44:
      45:     /** The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS) */
      46:     const NUM_HYDRATE_COLUMNS = 8;
      47:
      48:     /** the column name for the ID field */
      49:     const ID = 'content_version.ID';
      50:
      51:     /** the column name for the VISIBLE field */
      52:     const VISIBLE = 'content_version.VISIBLE';
      53:
      54:     /** the column name for the POSITION field */
      55:     const POSITION = 'content_version.POSITION';
      56:
      57:     /** the column name for the CREATED_AT field */
      58:     const CREATED_AT = 'content_version.CREATED_AT';
      59:
      60:     /** the column name for the UPDATED_AT field */
      61:     const UPDATED_AT = 'content_version.UPDATED_AT';
      62:
      63:     /** the column name for the VERSION field */
      64:     const VERSION = 'content_version.VERSION';
      65:
      66:     /** the column name for the VERSION_CREATED_AT field */
      67:     const VERSION_CREATED_AT = 'content_version.VERSION_CREATED_AT';
      68:
      69:     /** the column name for the VERSION_CREATED_BY field */
      70:     const VERSION_CREATED_BY = 'content_version.VERSION_CREATED_BY';
      71:
      72:     /** The default string format for model objects of the related table **/
      73:     const DEFAULT_STRING_FORMAT = 'YAML';
      74:
      75:     /**
      76:      * An identiy map to hold any loaded instances of ContentVersion objects.
      77:      * This must be public so that other peer classes can access this when hydrating from JOIN
      78:      * queries.
      79:      * @var        array ContentVersion[]
      80:      */
      81:     public static $instances = array();
      82:
      83:
      84:     /**
      85:      * holds an array of fieldnames
      86:      *
      87:      * first dimension keys are the type constants
      88:      * e.g. ContentVersionPeer::$fieldNames[ContentVersionPeer::TYPE_PHPNAME][0] = 'Id'
      89:      */
      90:     protected static $fieldNames = array (
      91:         BasePeer::TYPE_PHPNAME => array ('Id', 'Visible', 'Position', 'CreatedAt', 'UpdatedAt', 'Version', 'VersionCreatedAt', 'VersionCreatedBy', ),
      92:         BasePeer::TYPE_STUDLYPHPNAME => array ('id', 'visible', 'position', 'createdAt', 'updatedAt', 'version', 'versionCreatedAt', 'versionCreatedBy', ),
      93:         BasePeer::TYPE_COLNAME => array (ContentVersionPeer::ID, ContentVersionPeer::VISIBLE, ContentVersionPeer::POSITION, ContentVersionPeer::CREATED_AT, ContentVersionPeer::UPDATED_AT, ContentVersionPeer::VERSION, ContentVersionPeer::VERSION_CREATED_AT, ContentVersionPeer::VERSION_CREATED_BY, ),
      94:         BasePeer::TYPE_RAW_COLNAME => array ('ID', 'VISIBLE', 'POSITION', 'CREATED_AT', 'UPDATED_AT', 'VERSION', 'VERSION_CREATED_AT', 'VERSION_CREATED_BY', ),
      95:         BasePeer::TYPE_FIELDNAME => array ('id', 'visible', 'position', 'created_at', 'updated_at', 'version', 'version_created_at', 'version_created_by', ),
      96:         BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, )
      97:     );
      98:
      99:     /**
     100:      * holds an array of keys for quick access to the fieldnames array
     101:      *
     102:      * first dimension keys are the type constants
     103:      * e.g. ContentVersionPeer::$fieldNames[BasePeer::TYPE_PHPNAME]['Id'] = 0
     104:      */
     105:     protected static $fieldKeys = array (
     106:         BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'Visible' => 1, 'Position' => 2, 'CreatedAt' => 3, 'UpdatedAt' => 4, 'Version' => 5, 'VersionCreatedAt' => 6, 'VersionCreatedBy' => 7, ),
     107:         BasePeer::TYPE_STUDLYPHPNAME => array ('id' => 0, 'visible' => 1, 'position' => 2, 'createdAt' => 3, 'updatedAt' => 4, 'version' => 5, 'versionCreatedAt' => 6, 'versionCreatedBy' => 7, ),
     108:         BasePeer::TYPE_COLNAME => array (ContentVersionPeer::ID => 0, ContentVersionPeer::VISIBLE => 1, ContentVersionPeer::POSITION => 2, ContentVersionPeer::CREATED_AT => 3, ContentVersionPeer::UPDATED_AT => 4, ContentVersionPeer::VERSION => 5, ContentVersionPeer::VERSION_CREATED_AT => 6, ContentVersionPeer::VERSION_CREATED_BY => 7, ),
     109:         BasePeer::TYPE_RAW_COLNAME => array ('ID' => 0, 'VISIBLE' => 1, 'POSITION' => 2, 'CREATED_AT' => 3, 'UPDATED_AT' => 4, 'VERSION' => 5, 'VERSION_CREATED_AT' => 6, 'VERSION_CREATED_BY' => 7, ),
     110:         BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'visible' => 1, 'position' => 2, 'created_at' => 3, 'updated_at' => 4, 'version' => 5, 'version_created_at' => 6, 'version_created_by' => 7, ),
     111:         BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, )
     112:     );
     113:
     114:     /**
     115:      * Translates a fieldname to another type
     116:      *
     117:      * @param      string $name field name
     118:      * @param      string $fromType One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     119:      *                         BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
     120:      * @param      string $toType   One of the class type constants
     121:      * @return string          translated name of the field.
     122:      * @throws PropelException - if the specified name could not be found in the fieldname mappings.
     123:      */
     124:     public static function translateFieldName($name, $fromType, $toType)
     125:     {
     126:         $toNames = ContentVersionPeer::getFieldNames($toType);
     127:         $key = isset(ContentVersionPeer::$fieldKeys[$fromType][$name]) ? ContentVersionPeer::$fieldKeys[$fromType][$name] : null;
     128:         if ($key === null) {
     129:             throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(ContentVersionPeer::$fieldKeys[$fromType], true));
     130:         }
     131:
     132:         return $toNames[$key];
     133:     }
     134:
     135:     /**
     136:      * Returns an array of field names.
     137:      *
     138:      * @param      string $type The type of fieldnames to return:
     139:      *                      One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     140:      *                      BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
     141:      * @return array           A list of field names
     142:      * @throws PropelException - if the type is not valid.
     143:      */
     144:     public static function getFieldNames($type = BasePeer::TYPE_PHPNAME)
     145:     {
     146:         if (!array_key_exists($type, ContentVersionPeer::$fieldNames)) {
     147:             throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME, BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. ' . $type . ' was given.');
     148:         }
     149:
     150:         return ContentVersionPeer::$fieldNames[$type];
     151:     }
     152:
     153:     /**
     154:      * Convenience method which changes table.column to alias.column.
     155:      *
     156:      * Using this method you can maintain SQL abstraction while using column aliases.
     157:      * <code>
     158:      *      $c->addAlias("alias1", TablePeer::TABLE_NAME);
     159:      *      $c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
     160:      * </code>
     161:      * @param      string $alias The alias for the current table.
     162:      * @param      string $column The column name for current table. (i.e. ContentVersionPeer::COLUMN_NAME).
     163:      * @return string
     164:      */
     165:     public static function alias($alias, $column)
     166:     {
     167:         return str_replace(ContentVersionPeer::TABLE_NAME.'.', $alias.'.', $column);
     168:     }
     169:
     170:     /**
     171:      * Add all the columns needed to create a new object.
     172:      *
     173:      * Note: any columns that were marked with lazyLoad="true" in the
     174:      * XML schema will not be added to the select list and only loaded
     175:      * on demand.
     176:      *
     177:      * @param      Criteria $criteria object containing the columns to add.
     178:      * @param      string   $alias    optional table alias
     179:      * @throws PropelException Any exceptions caught during processing will be
     180:      *       rethrown wrapped into a PropelException.
     181:      */
     182:     public static function addSelectColumns(Criteria $criteria, $alias = null)
     183:     {
     184:         if (null === $alias) {
     185:             $criteria->addSelectColumn(ContentVersionPeer::ID);
     186:             $criteria->addSelectColumn(ContentVersionPeer::VISIBLE);
     187:             $criteria->addSelectColumn(ContentVersionPeer::POSITION);
     188:             $criteria->addSelectColumn(ContentVersionPeer::CREATED_AT);
     189:             $criteria->addSelectColumn(ContentVersionPeer::UPDATED_AT);
     190:             $criteria->addSelectColumn(ContentVersionPeer::VERSION);
     191:             $criteria->addSelectColumn(ContentVersionPeer::VERSION_CREATED_AT);
     192:             $criteria->addSelectColumn(ContentVersionPeer::VERSION_CREATED_BY);
     193:         } else {
     194:             $criteria->addSelectColumn($alias . '.ID');
     195:             $criteria->addSelectColumn($alias . '.VISIBLE');
     196:             $criteria->addSelectColumn($alias . '.POSITION');
     197:             $criteria->addSelectColumn($alias . '.CREATED_AT');
     198:             $criteria->addSelectColumn($alias . '.UPDATED_AT');
     199:             $criteria->addSelectColumn($alias . '.VERSION');
     200:             $criteria->addSelectColumn($alias . '.VERSION_CREATED_AT');
     201:             $criteria->addSelectColumn($alias . '.VERSION_CREATED_BY');
     202:         }
     203:     }
     204:
     205:     /**
     206:      * Returns the number of rows matching criteria.
     207:      *
     208:      * @param      Criteria $criteria
     209:      * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     210:      * @param      PropelPDO $con
     211:      * @return int Number of matching rows.
     212:      */
     213:     public static function doCount(Criteria $criteria, $distinct = false, PropelPDO $con = null)
     214:     {
     215:         // we may modify criteria, so copy it first
     216:         $criteria = clone $criteria;
     217:
     218:         // We need to set the primary table name, since in the case that there are no WHERE columns
     219:         // it will be impossible for the BasePeer::createSelectSql() method to determine which
     220:         // tables go into the FROM clause.
     221:         $criteria->setPrimaryTableName(ContentVersionPeer::TABLE_NAME);
     222:
     223:         if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
     224:             $criteria->setDistinct();
     225:         }
     226:
     227:         if (!$criteria->hasSelectClause()) {
     228:             ContentVersionPeer::addSelectColumns($criteria);
     229:         }
     230:
     231:         $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
     232:         $criteria->setDbName(ContentVersionPeer::DATABASE_NAME); // Set the correct dbName
     233:
     234:         if ($con === null) {
     235:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_READ);
     236:         }
     237:         // BasePeer returns a PDOStatement
     238:         $stmt = BasePeer::doCount($criteria, $con);
     239:
     240:         if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     241:             $count = (int) $row[0];
     242:         } else {
     243:             $count = 0; // no rows returned; we infer that means 0 matches.
     244:         }
     245:         $stmt->closeCursor();
     246:
     247:         return $count;
     248:     }
     249:     /**
     250:      * Selects one object from the DB.
     251:      *
     252:      * @param      Criteria $criteria object used to create the SELECT statement.
     253:      * @param      PropelPDO $con
     254:      * @return                 ContentVersion
     255:      * @throws PropelException Any exceptions caught during processing will be
     256:      *       rethrown wrapped into a PropelException.
     257:      */
     258:     public static function doSelectOne(Criteria $criteria, PropelPDO $con = null)
     259:     {
     260:         $critcopy = clone $criteria;
     261:         $critcopy->setLimit(1);
     262:         $objects = ContentVersionPeer::doSelect($critcopy, $con);
     263:         if ($objects) {
     264:             return $objects[0];
     265:         }
     266:
     267:         return null;
     268:     }
     269:     /**
     270:      * Selects several row from the DB.
     271:      *
     272:      * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
     273:      * @param      PropelPDO $con
     274:      * @return array           Array of selected Objects
     275:      * @throws PropelException Any exceptions caught during processing will be
     276:      *       rethrown wrapped into a PropelException.
     277:      */
     278:     public static function doSelect(Criteria $criteria, PropelPDO $con = null)
     279:     {
     280:         return ContentVersionPeer::populateObjects(ContentVersionPeer::doSelectStmt($criteria, $con));
     281:     }
     282:     /**
     283:      * Prepares the Criteria object and uses the parent doSelect() method to execute a PDOStatement.
     284:      *
     285:      * Use this method directly if you want to work with an executed statement durirectly (for example
     286:      * to perform your own object hydration).
     287:      *
     288:      * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
     289:      * @param      PropelPDO $con The connection to use
     290:      * @throws PropelException Any exceptions caught during processing will be
     291:      *       rethrown wrapped into a PropelException.
     292:      * @return PDOStatement The executed PDOStatement object.
     293:      * @see        BasePeer::doSelect()
     294:      */
     295:     public static function doSelectStmt(Criteria $criteria, PropelPDO $con = null)
     296:     {
     297:         if ($con === null) {
     298:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_READ);
     299:         }
     300:
     301:         if (!$criteria->hasSelectClause()) {
     302:             $criteria = clone $criteria;
     303:             ContentVersionPeer::addSelectColumns($criteria);
     304:         }
     305:
     306:         // Set the correct dbName
     307:         $criteria->setDbName(ContentVersionPeer::DATABASE_NAME);
     308:
     309:         // BasePeer returns a PDOStatement
     310:         return BasePeer::doSelect($criteria, $con);
     311:     }
     312:     /**
     313:      * Adds an object to the instance pool.
     314:      *
     315:      * Propel keeps cached copies of objects in an instance pool when they are retrieved
     316:      * from the database.  In some cases -- especially when you override doSelect*()
     317:      * methods in your stub classes -- you may need to explicitly add objects
     318:      * to the cache in order to ensure that the same objects are always returned by doSelect*()
     319:      * and retrieveByPK*() calls.
     320:      *
     321:      * @param      ContentVersion $obj A ContentVersion object.
     322:      * @param      string $key (optional) key to use for instance map (for performance boost if key was already calculated externally).
     323:      */
     324:     public static function addInstanceToPool($obj, $key = null)
     325:     {
     326:         if (Propel::isInstancePoolingEnabled()) {
     327:             if ($key === null) {
     328:                 $key = serialize(array((string) $obj->getId(), (string) $obj->getVersion()));
     329:             } // if key === null
     330:             ContentVersionPeer::$instances[$key] = $obj;
     331:         }
     332:     }
     333:
     334:     /**
     335:      * Removes an object from the instance pool.
     336:      *
     337:      * Propel keeps cached copies of objects in an instance pool when they are retrieved
     338:      * from the database.  In some cases -- especially when you override doDelete
     339:      * methods in your stub classes -- you may need to explicitly remove objects
     340:      * from the cache in order to prevent returning objects that no longer exist.
     341:      *
     342:      * @param      mixed $value A ContentVersion object or a primary key value.
     343:      *
     344:      * @return void
     345:      * @throws PropelException - if the value is invalid.
     346:      */
     347:     public static function removeInstanceFromPool($value)
     348:     {
     349:         if (Propel::isInstancePoolingEnabled() && $value !== null) {
     350:             if (is_object($value) && $value instanceof ContentVersion) {
     351:                 $key = serialize(array((string) $value->getId(), (string) $value->getVersion()));
     352:             } elseif (is_array($value) && count($value) === 2) {
     353:                 // assume we've been passed a primary key
     354:                 $key = serialize(array((string) $value[0], (string) $value[1]));
     355:             } else {
     356:                 $e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or ContentVersion object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value,true)));
     357:                 throw $e;
     358:             }
     359:
     360:             unset(ContentVersionPeer::$instances[$key]);
     361:         }
     362:     } // removeInstanceFromPool()
     363:
     364:     /**
     365:      * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     366:      *
     367:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     368:      * a multi-column primary key, a serialize()d version of the primary key will be returned.
     369:      *
     370:      * @param      string $key The key (@see getPrimaryKeyHash()) for this instance.
     371:      * @return   ContentVersion Found object or null if 1) no instance exists for specified key or 2) instance pooling has been disabled.
     372:      * @see        getPrimaryKeyHash()
     373:      */
     374:     public static function getInstanceFromPool($key)
     375:     {
     376:         if (Propel::isInstancePoolingEnabled()) {
     377:             if (isset(ContentVersionPeer::$instances[$key])) {
     378:                 return ContentVersionPeer::$instances[$key];
     379:             }
     380:         }
     381:
     382:         return null; // just to be explicit
     383:     }
     384:
     385:     /**
     386:      * Clear the instance pool.
     387:      *
     388:      * @return void
     389:      */
     390:     public static function clearInstancePool()
     391:     {
     392:         ContentVersionPeer::$instances = array();
     393:     }
     394:
     395:     /**
     396:      * Method to invalidate the instance pool of all tables related to content_version
     397:      * by a foreign key with ON DELETE CASCADE
     398:      */
     399:     public static function clearRelatedInstancePool()
     400:     {
     401:     }
     402:
     403:     /**
     404:      * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     405:      *
     406:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     407:      * a multi-column primary key, a serialize()d version of the primary key will be returned.
     408:      *
     409:      * @param      array $row PropelPDO resultset row.
     410:      * @param      int $startcol The 0-based offset for reading from the resultset row.
     411:      * @return string A string version of PK or null if the components of primary key in result array are all null.
     412:      */
     413:     public static function getPrimaryKeyHashFromRow($row, $startcol = 0)
     414:     {
     415:         // If the PK cannot be derived from the row, return null.
     416:         if ($row[$startcol] === null && $row[$startcol + 5] === null) {
     417:             return null;
     418:         }
     419:
     420:         return serialize(array((string) $row[$startcol], (string) $row[$startcol + 5]));
     421:     }
     422:
     423:     /**
     424:      * Retrieves the primary key from the DB resultset row
     425:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     426:      * a multi-column primary key, an array of the primary key columns will be returned.
     427:      *
     428:      * @param      array $row PropelPDO resultset row.
     429:      * @param      int $startcol The 0-based offset for reading from the resultset row.
     430:      * @return mixed The primary key of the row
     431:      */
     432:     public static function getPrimaryKeyFromRow($row, $startcol = 0)
     433:     {
     434:
     435:         return array((int) $row[$startcol], (int) $row[$startcol + 5]);
     436:     }
     437:
     438:     /**
     439:      * The returned array will contain objects of the default type or
     440:      * objects that inherit from the default.
     441:      *
     442:      * @throws PropelException Any exceptions caught during processing will be
     443:      *       rethrown wrapped into a PropelException.
     444:      */
     445:     public static function populateObjects(PDOStatement $stmt)
     446:     {
     447:         $results = array();
     448:
     449:         // set the class once to avoid overhead in the loop
     450:         $cls = ContentVersionPeer::getOMClass();
     451:         // populate the object(s)
     452:         while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     453:             $key = ContentVersionPeer::getPrimaryKeyHashFromRow($row, 0);
     454:             if (null !== ($obj = ContentVersionPeer::getInstanceFromPool($key))) {
     455:                 // We no longer rehydrate the object, since this can cause data loss.
     456:                 // See http://www.propelorm.org/ticket/509
     457:                 // $obj->hydrate($row, 0, true); // rehydrate
     458:                 $results[] = $obj;
     459:             } else {
     460:                 $obj = new $cls();
     461:                 $obj->hydrate($row);
     462:                 $results[] = $obj;
     463:                 ContentVersionPeer::addInstanceToPool($obj, $key);
     464:             } // if key exists
     465:         }
     466:         $stmt->closeCursor();
     467:
     468:         return $results;
     469:     }
     470:     /**
     471:      * Populates an object of the default type or an object that inherit from the default.
     472:      *
     473:      * @param      array $row PropelPDO resultset row.
     474:      * @param      int $startcol The 0-based offset for reading from the resultset row.
     475:      * @throws PropelException Any exceptions caught during processing will be
     476:      *       rethrown wrapped into a PropelException.
     477:      * @return array (ContentVersion object, last column rank)
     478:      */
     479:     public static function populateObject($row, $startcol = 0)
     480:     {
     481:         $key = ContentVersionPeer::getPrimaryKeyHashFromRow($row, $startcol);
     482:         if (null !== ($obj = ContentVersionPeer::getInstanceFromPool($key))) {
     483:             // We no longer rehydrate the object, since this can cause data loss.
     484:             // See http://www.propelorm.org/ticket/509
     485:             // $obj->hydrate($row, $startcol, true); // rehydrate
     486:             $col = $startcol + ContentVersionPeer::NUM_HYDRATE_COLUMNS;
     487:         } else {
     488:             $cls = ContentVersionPeer::OM_CLASS;
     489:             $obj = new $cls();
     490:             $col = $obj->hydrate($row, $startcol);
     491:             ContentVersionPeer::addInstanceToPool($obj, $key);
     492:         }
     493:
     494:         return array($obj, $col);
     495:     }
     496:
     497:
     498:     /**
     499:      * Returns the number of rows matching criteria, joining the related Content table
     500:      *
     501:      * @param      Criteria $criteria
     502:      * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     503:      * @param      PropelPDO $con
     504:      * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     505:      * @return int Number of matching rows.
     506:      */
     507:     public static function doCountJoinContent(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
     508:     {
     509:         // we're going to modify criteria, so copy it first
     510:         $criteria = clone $criteria;
     511:
     512:         // We need to set the primary table name, since in the case that there are no WHERE columns
     513:         // it will be impossible for the BasePeer::createSelectSql() method to determine which
     514:         // tables go into the FROM clause.
     515:         $criteria->setPrimaryTableName(ContentVersionPeer::TABLE_NAME);
     516:
     517:         if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
     518:             $criteria->setDistinct();
     519:         }
     520:
     521:         if (!$criteria->hasSelectClause()) {
     522:             ContentVersionPeer::addSelectColumns($criteria);
     523:         }
     524:
     525:         $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
     526:
     527:         // Set the correct dbName
     528:         $criteria->setDbName(ContentVersionPeer::DATABASE_NAME);
     529:
     530:         if ($con === null) {
     531:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_READ);
     532:         }
     533:
     534:         $criteria->addJoin(ContentVersionPeer::ID, ContentPeer::ID, $join_behavior);
     535:
     536:         $stmt = BasePeer::doCount($criteria, $con);
     537:
     538:         if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     539:             $count = (int) $row[0];
     540:         } else {
     541:             $count = 0; // no rows returned; we infer that means 0 matches.
     542:         }
     543:         $stmt->closeCursor();
     544:
     545:         return $count;
     546:     }
     547:
     548:
     549:     /**
     550:      * Selects a collection of ContentVersion objects pre-filled with their Content objects.
     551:      * @param      Criteria  $criteria
     552:      * @param      PropelPDO $con
     553:      * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     554:      * @return array           Array of ContentVersion objects.
     555:      * @throws PropelException Any exceptions caught during processing will be
     556:      *       rethrown wrapped into a PropelException.
     557:      */
     558:     public static function doSelectJoinContent(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
     559:     {
     560:         $criteria = clone $criteria;
     561:
     562:         // Set the correct dbName if it has not been overridden
     563:         if ($criteria->getDbName() == Propel::getDefaultDB()) {
     564:             $criteria->setDbName(ContentVersionPeer::DATABASE_NAME);
     565:         }
     566:
     567:         ContentVersionPeer::addSelectColumns($criteria);
     568:         $startcol = ContentVersionPeer::NUM_HYDRATE_COLUMNS;
     569:         ContentPeer::addSelectColumns($criteria);
     570:
     571:         $criteria->addJoin(ContentVersionPeer::ID, ContentPeer::ID, $join_behavior);
     572:
     573:         $stmt = BasePeer::doSelect($criteria, $con);
     574:         $results = array();
     575:
     576:         while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     577:             $key1 = ContentVersionPeer::getPrimaryKeyHashFromRow($row, 0);
     578:             if (null !== ($obj1 = ContentVersionPeer::getInstanceFromPool($key1))) {
     579:                 // We no longer rehydrate the object, since this can cause data loss.
     580:                 // See http://www.propelorm.org/ticket/509
     581:                 // $obj1->hydrate($row, 0, true); // rehydrate
     582:             } else {
     583:
     584:                 $cls = ContentVersionPeer::getOMClass();
     585:
     586:                 $obj1 = new $cls();
     587:                 $obj1->hydrate($row);
     588:                 ContentVersionPeer::addInstanceToPool($obj1, $key1);
     589:             } // if $obj1 already loaded
     590:
     591:             $key2 = ContentPeer::getPrimaryKeyHashFromRow($row, $startcol);
     592:             if ($key2 !== null) {
     593:                 $obj2 = ContentPeer::getInstanceFromPool($key2);
     594:                 if (!$obj2) {
     595:
     596:                     $cls = ContentPeer::getOMClass();
     597:
     598:                     $obj2 = new $cls();
     599:                     $obj2->hydrate($row, $startcol);
     600:                     ContentPeer::addInstanceToPool($obj2, $key2);
     601:                 } // if obj2 already loaded
     602:
     603:                 // Add the $obj1 (ContentVersion) to $obj2 (Content)
     604:                 $obj2->addContentVersion($obj1);
     605:
     606:             } // if joined row was not null
     607:
     608:             $results[] = $obj1;
     609:         }
     610:         $stmt->closeCursor();
     611:
     612:         return $results;
     613:     }
     614:
     615:
     616:     /**
     617:      * Returns the number of rows matching criteria, joining all related tables
     618:      *
     619:      * @param      Criteria $criteria
     620:      * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     621:      * @param      PropelPDO $con
     622:      * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     623:      * @return int Number of matching rows.
     624:      */
     625:     public static function doCountJoinAll(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
     626:     {
     627:         // we're going to modify criteria, so copy it first
     628:         $criteria = clone $criteria;
     629:
     630:         // We need to set the primary table name, since in the case that there are no WHERE columns
     631:         // it will be impossible for the BasePeer::createSelectSql() method to determine which
     632:         // tables go into the FROM clause.
     633:         $criteria->setPrimaryTableName(ContentVersionPeer::TABLE_NAME);
     634:
     635:         if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
     636:             $criteria->setDistinct();
     637:         }
     638:
     639:         if (!$criteria->hasSelectClause()) {
     640:             ContentVersionPeer::addSelectColumns($criteria);
     641:         }
     642:
     643:         $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
     644:
     645:         // Set the correct dbName
     646:         $criteria->setDbName(ContentVersionPeer::DATABASE_NAME);
     647:
     648:         if ($con === null) {
     649:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_READ);
     650:         }
     651:
     652:         $criteria->addJoin(ContentVersionPeer::ID, ContentPeer::ID, $join_behavior);
     653:
     654:         $stmt = BasePeer::doCount($criteria, $con);
     655:
     656:         if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     657:             $count = (int) $row[0];
     658:         } else {
     659:             $count = 0; // no rows returned; we infer that means 0 matches.
     660:         }
     661:         $stmt->closeCursor();
     662:
     663:         return $count;
     664:     }
     665:
     666:     /**
     667:      * Selects a collection of ContentVersion objects pre-filled with all related objects.
     668:      *
     669:      * @param      Criteria  $criteria
     670:      * @param      PropelPDO $con
     671:      * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     672:      * @return array           Array of ContentVersion objects.
     673:      * @throws PropelException Any exceptions caught during processing will be
     674:      *       rethrown wrapped into a PropelException.
     675:      */
     676:     public static function doSelectJoinAll(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
     677:     {
     678:         $criteria = clone $criteria;
     679:
     680:         // Set the correct dbName if it has not been overridden
     681:         if ($criteria->getDbName() == Propel::getDefaultDB()) {
     682:             $criteria->setDbName(ContentVersionPeer::DATABASE_NAME);
     683:         }
     684:
     685:         ContentVersionPeer::addSelectColumns($criteria);
     686:         $startcol2 = ContentVersionPeer::NUM_HYDRATE_COLUMNS;
     687:
     688:         ContentPeer::addSelectColumns($criteria);
     689:         $startcol3 = $startcol2 + ContentPeer::NUM_HYDRATE_COLUMNS;
     690:
     691:         $criteria->addJoin(ContentVersionPeer::ID, ContentPeer::ID, $join_behavior);
     692:
     693:         $stmt = BasePeer::doSelect($criteria, $con);
     694:         $results = array();
     695:
     696:         while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
     697:             $key1 = ContentVersionPeer::getPrimaryKeyHashFromRow($row, 0);
     698:             if (null !== ($obj1 = ContentVersionPeer::getInstanceFromPool($key1))) {
     699:                 // We no longer rehydrate the object, since this can cause data loss.
     700:                 // See http://www.propelorm.org/ticket/509
     701:                 // $obj1->hydrate($row, 0, true); // rehydrate
     702:             } else {
     703:                 $cls = ContentVersionPeer::getOMClass();
     704:
     705:                 $obj1 = new $cls();
     706:                 $obj1->hydrate($row);
     707:                 ContentVersionPeer::addInstanceToPool($obj1, $key1);
     708:             } // if obj1 already loaded
     709:
     710:             // Add objects for joined Content rows
     711:
     712:             $key2 = ContentPeer::getPrimaryKeyHashFromRow($row, $startcol2);
     713:             if ($key2 !== null) {
     714:                 $obj2 = ContentPeer::getInstanceFromPool($key2);
     715:                 if (!$obj2) {
     716:
     717:                     $cls = ContentPeer::getOMClass();
     718:
     719:                     $obj2 = new $cls();
     720:                     $obj2->hydrate($row, $startcol2);
     721:                     ContentPeer::addInstanceToPool($obj2, $key2);
     722:                 } // if obj2 loaded
     723:
     724:                 // Add the $obj1 (ContentVersion) to the collection in $obj2 (Content)
     725:                 $obj2->addContentVersion($obj1);
     726:             } // if joined row not null
     727:
     728:             $results[] = $obj1;
     729:         }
     730:         $stmt->closeCursor();
     731:
     732:         return $results;
     733:     }
     734:
     735:     /**
     736:      * Returns the TableMap related to this peer.
     737:      * This method is not needed for general use but a specific application could have a need.
     738:      * @return TableMap
     739:      * @throws PropelException Any exceptions caught during processing will be
     740:      *       rethrown wrapped into a PropelException.
     741:      */
     742:     public static function getTableMap()
     743:     {
     744:         return Propel::getDatabaseMap(ContentVersionPeer::DATABASE_NAME)->getTable(ContentVersionPeer::TABLE_NAME);
     745:     }
     746:
     747:     /**
     748:      * Add a TableMap instance to the database for this peer class.
     749:      */
     750:     public static function buildTableMap()
     751:     {
     752:       $dbMap = Propel::getDatabaseMap(BaseContentVersionPeer::DATABASE_NAME);
     753:       if (!$dbMap->hasTable(BaseContentVersionPeer::TABLE_NAME)) {
     754:         $dbMap->addTableObject(new ContentVersionTableMap());
     755:       }
     756:     }
     757:
     758:     /**
     759:      * The class that the Peer will make instances of.
     760:      *
     761:      *
     762:      * @return string ClassName
     763:      */
     764:     public static function getOMClass()
     765:     {
     766:         return ContentVersionPeer::OM_CLASS;
     767:     }
     768:
     769:     /**
     770:      * Performs an INSERT on the database, given a ContentVersion or Criteria object.
     771:      *
     772:      * @param      mixed $values Criteria or ContentVersion object containing data that is used to create the INSERT statement.
     773:      * @param      PropelPDO $con the PropelPDO connection to use
     774:      * @return mixed           The new primary key.
     775:      * @throws PropelException Any exceptions caught during processing will be
     776:      *       rethrown wrapped into a PropelException.
     777:      */
     778:     public static function doInsert($values, PropelPDO $con = null)
     779:     {
     780:         if ($con === null) {
     781:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
     782:         }
     783:
     784:         if ($values instanceof Criteria) {
     785:             $criteria = clone $values; // rename for clarity
     786:         } else {
     787:             $criteria = $values->buildCriteria(); // build Criteria from ContentVersion object
     788:         }
     789:
     790:
     791:         // Set the correct dbName
     792:         $criteria->setDbName(ContentVersionPeer::DATABASE_NAME);
     793:
     794:         try {
     795:             // use transaction because $criteria could contain info
     796:             // for more than one table (I guess, conceivably)
     797:             $con->beginTransaction();
     798:             $pk = BasePeer::doInsert($criteria, $con);
     799:             $con->commit();
     800:         } catch (PropelException $e) {
     801:             $con->rollBack();
     802:             throw $e;
     803:         }
     804:
     805:         return $pk;
     806:     }
     807:
     808:     /**
     809:      * Performs an UPDATE on the database, given a ContentVersion or Criteria object.
     810:      *
     811:      * @param      mixed $values Criteria or ContentVersion object containing data that is used to create the UPDATE statement.
     812:      * @param      PropelPDO $con The connection to use (specify PropelPDO connection object to exert more control over transactions).
     813:      * @return int             The number of affected rows (if supported by underlying database driver).
     814:      * @throws PropelException Any exceptions caught during processing will be
     815:      *       rethrown wrapped into a PropelException.
     816:      */
     817:     public static function doUpdate($values, PropelPDO $con = null)
     818:     {
     819:         if ($con === null) {
     820:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
     821:         }
     822:
     823:         $selectCriteria = new Criteria(ContentVersionPeer::DATABASE_NAME);
     824:
     825:         if ($values instanceof Criteria) {
     826:             $criteria = clone $values; // rename for clarity
     827:
     828:             $comparison = $criteria->getComparison(ContentVersionPeer::ID);
     829:             $value = $criteria->remove(ContentVersionPeer::ID);
     830:             if ($value) {
     831:                 $selectCriteria->add(ContentVersionPeer::ID, $value, $comparison);
     832:             } else {
     833:                 $selectCriteria->setPrimaryTableName(ContentVersionPeer::TABLE_NAME);
     834:             }
     835:
     836:             $comparison = $criteria->getComparison(ContentVersionPeer::VERSION);
     837:             $value = $criteria->remove(ContentVersionPeer::VERSION);
     838:             if ($value) {
     839:                 $selectCriteria->add(ContentVersionPeer::VERSION, $value, $comparison);
     840:             } else {
     841:                 $selectCriteria->setPrimaryTableName(ContentVersionPeer::TABLE_NAME);
     842:             }
     843:
     844:         } else { // $values is ContentVersion object
     845:             $criteria = $values->buildCriteria(); // gets full criteria
     846:             $selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)
     847:         }
     848:
     849:         // set the correct dbName
     850:         $criteria->setDbName(ContentVersionPeer::DATABASE_NAME);
     851:
     852:         return BasePeer::doUpdate($selectCriteria, $criteria, $con);
     853:     }
     854:
     855:     /**
     856:      * Deletes all rows from the content_version table.
     857:      *
     858:      * @param      PropelPDO $con the connection to use
     859:      * @return int             The number of affected rows (if supported by underlying database driver).
     860:      * @throws PropelException
     861:      */
     862:     public static function doDeleteAll(PropelPDO $con = null)
     863:     {
     864:         if ($con === null) {
     865:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
     866:         }
     867:         $affectedRows = 0; // initialize var to track total num of affected rows
     868:         try {
     869:             // use transaction because $criteria could contain info
     870:             // for more than one table or we could emulating ON DELETE CASCADE, etc.
     871:             $con->beginTransaction();
     872:             $affectedRows += BasePeer::doDeleteAll(ContentVersionPeer::TABLE_NAME, $con, ContentVersionPeer::DATABASE_NAME);
     873:             // Because this db requires some delete cascade/set null emulation, we have to
     874:             // clear the cached instance *after* the emulation has happened (since
     875:             // instances get re-added by the select statement contained therein).
     876:             ContentVersionPeer::clearInstancePool();
     877:             ContentVersionPeer::clearRelatedInstancePool();
     878:             $con->commit();
     879:
     880:             return $affectedRows;
     881:         } catch (PropelException $e) {
     882:             $con->rollBack();
     883:             throw $e;
     884:         }
     885:     }
     886:
     887:     /**
     888:      * Performs a DELETE on the database, given a ContentVersion or Criteria object OR a primary key value.
     889:      *
     890:      * @param      mixed $values Criteria or ContentVersion object or primary key or array of primary keys
     891:      *              which is used to create the DELETE statement
     892:      * @param      PropelPDO $con the connection to use
     893:      * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     894:      *              if supported by native driver or if emulated using Propel.
     895:      * @throws PropelException Any exceptions caught during processing will be
     896:      *       rethrown wrapped into a PropelException.
     897:      */
     898:      public static function doDelete($values, PropelPDO $con = null)
     899:      {
     900:         if ($con === null) {
     901:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
     902:         }
     903:
     904:         if ($values instanceof Criteria) {
     905:             // invalidate the cache for all objects of this type, since we have no
     906:             // way of knowing (without running a query) what objects should be invalidated
     907:             // from the cache based on this Criteria.
     908:             ContentVersionPeer::clearInstancePool();
     909:             // rename for clarity
     910:             $criteria = clone $values;
     911:         } elseif ($values instanceof ContentVersion) { // it's a model object
     912:             // invalidate the cache for this single object
     913:             ContentVersionPeer::removeInstanceFromPool($values);
     914:             // create criteria based on pk values
     915:             $criteria = $values->buildPkeyCriteria();
     916:         } else { // it's a primary key, or an array of pks
     917:             $criteria = new Criteria(ContentVersionPeer::DATABASE_NAME);
     918:             // primary key is composite; we therefore, expect
     919:             // the primary key passed to be an array of pkey values
     920:             if (count($values) == count($values, COUNT_RECURSIVE)) {
     921:                 // array is not multi-dimensional
     922:                 $values = array($values);
     923:             }
     924:             foreach ($values as $value) {
     925:                 $criterion = $criteria->getNewCriterion(ContentVersionPeer::ID, $value[0]);
     926:                 $criterion->addAnd($criteria->getNewCriterion(ContentVersionPeer::VERSION, $value[1]));
     927:                 $criteria->addOr($criterion);
     928:                 // we can invalidate the cache for this single PK
     929:                 ContentVersionPeer::removeInstanceFromPool($value);
     930:             }
     931:         }
     932:
     933:         // Set the correct dbName
     934:         $criteria->setDbName(ContentVersionPeer::DATABASE_NAME);
     935:
     936:         $affectedRows = 0; // initialize var to track total num of affected rows
     937:
     938:         try {
     939:             // use transaction because $criteria could contain info
     940:             // for more than one table or we could emulating ON DELETE CASCADE, etc.
     941:             $con->beginTransaction();
     942:
     943:             $affectedRows += BasePeer::doDelete($criteria, $con);
     944:             ContentVersionPeer::clearRelatedInstancePool();
     945:             $con->commit();
     946:
     947:             return $affectedRows;
     948:         } catch (PropelException $e) {
     949:             $con->rollBack();
     950:             throw $e;
     951:         }
     952:     }
     953:
     954:     /**
     955:      * Validates all modified columns of given ContentVersion object.
     956:      * If parameter $columns is either a single column name or an array of column names
     957:      * than only those columns are validated.
     958:      *
     959:      * NOTICE: This does not apply to primary or foreign keys for now.
     960:      *
     961:      * @param      ContentVersion $obj The object to validate.
     962:      * @param      mixed $cols Column name or array of column names.
     963:      *
     964:      * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
     965:      */
     966:     public static function doValidate($obj, $cols = null)
     967:     {
     968:         $columns = array();
     969:
     970:         if ($cols) {
     971:             $dbMap = Propel::getDatabaseMap(ContentVersionPeer::DATABASE_NAME);
     972:             $tableMap = $dbMap->getTable(ContentVersionPeer::TABLE_NAME);
     973:
     974:             if (! is_array($cols)) {
     975:                 $cols = array($cols);
     976:             }
     977:
     978:             foreach ($cols as $colName) {
     979:                 if ($tableMap->hasColumn($colName)) {
     980:                     $get = 'get' . $tableMap->getColumn($colName)->getPhpName();
     981:                     $columns[$colName] = $obj->$get();
     982:                 }
     983:             }
     984:         } else {
     985:
     986:         }
     987:
     988:         return BasePeer::doValidate(ContentVersionPeer::DATABASE_NAME, ContentVersionPeer::TABLE_NAME, $columns);
     989:     }
     990:
     991:     /**
     992:      * Retrieve object using using composite pkey values.
     993:      * @param   int $id
     994:      * @param   int $version
     995:      * @param      PropelPDO $con
     996:      * @return   ContentVersion
     997:      */
     998:     public static function retrieveByPK($id, $version, PropelPDO $con = null) {
     999:         $_instancePoolKey = serialize(array((string) $id, (string) $version));
    1000:          if (null !== ($obj = ContentVersionPeer::getInstanceFromPool($_instancePoolKey))) {
    1001:              return $obj;
    1002:         }
    1003:
    1004:         if ($con === null) {
    1005:             $con = Propel::getConnection(ContentVersionPeer::DATABASE_NAME, Propel::CONNECTION_READ);
    1006:         }
    1007:         $criteria = new Criteria(ContentVersionPeer::DATABASE_NAME);
    1008:         $criteria->add(ContentVersionPeer::ID, $id);
    1009:         $criteria->add(ContentVersionPeer::VERSION, $version);
    1010:         $v = ContentVersionPeer::doSelect($criteria, $con);
    1011:
    1012:         return !empty($v) ? $v[0] : null;
    1013:     }
    1014: } // BaseContentVersionPeer
    1015:
    1016: // This is the static code needed to register the TableMap for this table with the main Propel class.
    1017: //
    1018: BaseContentVersionPeer::buildTableMap();
    1019:
    1020: